﻿#region Copyright Syncfusion Inc. 2001 - 2016
// Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Reports.Viewer;
using Microsoft.Win32;
using System.Windows.Threading;
using System.IO;
using System.Collections;
using Syncfusion.Windows.Shared;
using System.Xml.Linq;
using System.Xml;
using System.Text.RegularExpressions;
using System.Xml.Serialization;
using Syncfusion.RDL.DOM;

namespace Syncfusion.Samples
{
    public partial class ReportView : Window
    {
        #region Constructor

        public ReportView()
        {
            InitializeComponent();
            SkinStorage.SetVisualStyle(this, "Metro");
            SerializeReport();
            this.Loaded += ReportView_Loaded;
        }

        private void ReportView_Loaded(object sender, RoutedEventArgs e)
        {
            this.viewer.ReportPath = new FileInfo("../../ParameterDemoModified.rdl").FullName;
            this.viewer.RefreshReport();
        }

        private void SerializeReport()
        {
            FileInfo info = new FileInfo("../../ParameterDemo.rdl");
            FileStream stream = new FileStream(info.FullName, FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);
            XElement rdl = XElement.Load(XmlReader.Create(stream));
            string Namespace = (from attribute in rdl.Attributes() where attribute.Name.LocalName == "xmlns" select attribute.Value).FirstOrDefault();
            string Version = (Regex.IsMatch(Namespace, @"\d{4}") ? Regex.Match(Namespace, @"\d{4}").Value : string.Empty);
            XmlSerializer xs = new XmlSerializer(typeof(Syncfusion.RDL.DOM.ReportDefinition), Namespace);
            Syncfusion.RDL.DOM.ReportDefinition reportDefinition;

            using (StringReader reader = new StringReader(rdl.ToString()))
            {
                reportDefinition = (Syncfusion.RDL.DOM.ReportDefinition)xs.Deserialize(reader);
            }

            if (reportDefinition != null && reportDefinition.ReportSections != null)
            {
                var section = reportDefinition.ReportSections.First();

                if (section.Page != null && section.Page.PageHeader != null && section.Page.PageHeader.ReportItems != null)
                {
                    foreach (var reportItem in section.Page.PageHeader.ReportItems)
                    {
                        if (reportItem is Syncfusion.RDL.DOM.TextBox)
                        {
                            var paragraphs = (reportItem as RDL.DOM.TextBox).Paragraphs;

                            if (paragraphs != null)
                            {
                                foreach (var paragraph in paragraphs)
                                {
                                    foreach (var textRun in paragraph.TextRuns)
                                    {
                                        if (textRun.Value == "Welcome")
                                            textRun.Value = "Bienvenido";
                                        else if (textRun.Value == "report test")
                                            textRun.Value = "Prueba de informe";
                                    }
                                }
                            }
                        }
                    }
                }
            }

            string nameSpace = "http://schemas.microsoft.com/sqlserver/reporting/2008/01/reportdefinition";

            if (Version == "2010")
            {
                nameSpace = "http://schemas.microsoft.com/sqlserver/reporting/2010/01/reportdefinition";
            }

            System.Xml.Serialization.XmlSerializerNamespaces serialize = new System.Xml.Serialization.XmlSerializerNamespaces();
            serialize.Add("rd", "http://schemas.microsoft.com/SQLServer/reporting/reportdesigner");
            XmlSerializer xs2 = new XmlSerializer(typeof(Syncfusion.RDL.DOM.ReportDefinition), nameSpace);
            MemoryStream memoryStream = new MemoryStream();
            TextWriter ws3 = new StreamWriter(@"../../ParameterDemoModified.rdl");
            xs2.Serialize(ws3, reportDefinition, serialize);
            stream.Close();
            ws3.Close();
        }

        #endregion
    }
}
